# Advisor local WSGI

Advisor wsgi server is used to **debug and develop Advisor backend** with the help of `DataikuAPI`.

### How to set up [ *VS code* ]

#### launch.json

- Create a VS Code **workspace** or a **launch config**.
- Copy the contents of `vs-code-launch.json.example` in the root folder into the `.vscode` folder's launch config or replace the launch section of `.workspace` file
- Replace the highlighted with `${...}` sections with specific to your machine.

-  `PYTHONPATH`: you can set it either in your `launch` config or the `.env` file, both example files contain a tip.

#### creating a python virtual environment (venv)

- use python `3.7.15` *(recommended version)*
- in your terminal go to `code-env` and create a virtual environment:
```
[no python version management tools used]

➜  advisor git:(dev) ✗ cd code-env 
➜  code-env git:(dev) ✗ python -m venv venv
```
If you're using a tool like `pyenv`, then `VS Code` won't recognize your `venv` because it doesn't contain an actual python executable.
You have to add `--copies` option to your venv creation command for `pyenv` or a similar option for your tool:
```
[pyenv]

➜  advisor git:(dev) ✗ cd code-env 
➜  code-env git:(dev) ✗ python -m venv venv --copies
```

- install the advisor python requirements from `python/spec/requirements.txt`:
```
➜  code-env git:(dev) ✗ source venv/bin/activate
(venv) ➜  code-env git:(dev) ✗ pip install -r python/spec/requirements.txt
```
- set this virtual environment as your vs code virtual environment (https://code.visualstudio.com/docs/python/environments)

#### .env

- create a `.env` file in advisor root dir
- copy the contents of `.env-expample` to your `.env`
- replace the necessary variable values with your own

#### .env configuration
most of the information on how to fill different fields is described in the `.env-example`

- to get `FLASK_APP` path go to the root folder of your Advisor project in your console and do:
```
➜  advisor git:(dev) ✗ pwd
/Users/[PATH_TO_ADVISOR]/advisor
```
copy the path to advisor and append to it `/python-lib/backend/wsgi.py`
- to get `FS_PATH` path go to your user root folder in your console and do:
```
➜  advisor git(dev) ✗ cd ~/.dataiku/advisor/${DSS_PROJECT_KEY}/${DSS_WEBAPP_ID}
➜  ${DSS_WEBAPP_ID} pwd
[ABSOLUTE_PATH_TO_ADVISOR_DATABASE]
```
set `FS_PATH` to the `ABSOLUTE_PATH_TO_ADVISOR_DATABASE`.

#### Running
to launch `wsgi`server just press `F5` on your keyboard or go to **Run and Debug** section in vs code **(⇧⌘D)** and press the **run** button