import backend.controllers as ctrls
from backend.models import DssUser
from backend.utils.dataiku_api import dataiku_api
import re


class AuthController(ctrls.BaseController):
    def get_dss_auth_info(self, headers):
        auth_info = dataiku_api.get_auth_info(headers)
        return auth_info

    def get_dss_user(self, headers):
        try:
            user_info = dataiku_api.get_user_info(headers)
        except Exception:
            auth_info = dataiku_api.get_auth_info(headers)
            user_info = {
                "login": auth_info.get("associatedDSSUser"),
                "userProfile": auth_info.get("userProfile"),
            }
        return DssUser(**user_info)

    def get_current_dss_user(self, request):
        headers = dict(request.headers)
        dss_user: DssUser = self.get_dss_user(headers)
        return dss_user
