"""added view description

Revision ID: 697a95c78c24
Revises: ce6d7c3b0d89
Create Date: 2022-11-15 14:16:35.720438

"""
from alembic import op
import sqlalchemy as sa
from backend.models import View
from sqlalchemy import inspect


# revision identifiers, used by Alembic.
revision = "697a95c78c24"
down_revision = "ce6d7c3b0d89"
branch_labels = None
depends_on = None


def column_exists(table_name, column_name):
    bind = op.get_context().bind
    insp = inspect(bind)
    columns = insp.get_columns(table_name)
    return any(c["name"] == column_name for c in columns)


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    if not column_exists(View.__tablename__, "description"):
        op.add_column(View.__tablename__, sa.Column("description", sa.Text(), nullable=True))
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_column(View.__tablename__, "description")
    # ### end Alembic commands ###
