from flask import Blueprint
from .auth import auth
from .card import card
from .view import view
from .utils import utils
from .user_config import user_config
from .connection import connection
from .url_rule import url_rule
from .dataiku import dataiku

api = Blueprint("api", __name__, url_prefix="/api")

api.register_blueprint(auth)
api.register_blueprint(card)
api.register_blueprint(view)
api.register_blueprint(utils)
api.register_blueprint(user_config)
api.register_blueprint(connection)
api.register_blueprint(url_rule)
api.register_blueprint(dataiku)
