from marshmallow import Schema, fields
from backend.models.fed_url_rule import FedUrlRule
from backend.models.url_rule import UrlRuleMode
from marshmallow_enum import EnumField


class FedUrlRuleSchema(Schema):
    class Meta:
        model = FedUrlRule
        load_instance = True

    url_rule_id = fields.Number()
    mode = EnumField(UrlRuleMode)
    regex = fields.String()
    priority = fields.Integer()
    css_selectors = fields.List(fields.String)
